%define major_ver 3.1.10

%if %{?WITH_PAM:0}%{!?WITH_PAM:1}
%define WITH_PAM 1
%endif
Summary: Job spooling tools
Name: at
Version: 3.1.10
Release: 43%{?dist}.1
License: GPLv2+
Group: System Environment/Daemons
URL: http://ftp.debian.org/debian/pool/main/a/at
Source: http://ftp.debian.org/debian/pool/main/a/at/at_%{major_ver}.tar.gz
Source1: test.pl
Source2: atd.init
Source3: atd.sysconf
Source4: 56atd
Patch0: at-3.1.7-lockfile.patch
Patch1: at-3.1.10-makefile.patch
Patch2: at-3.1.10-man-timespec-path.patch
Patch3: at-3.1.7-sigchld.patch
Patch4: at-3.1.10-typo.patch
Patch5: at-3.1.8-perr.patch
Patch6: at-3.1.10-shell.patch
Patch7: at-3.1.8-t_option.patch
Patch8: at-3.1.10-pam.patch
Patch9: at-3.1.10-dont_fork.patch
Patch10: at-3.1.10-perm.patch
Patch11: at-3.1.10-opt_V.patch
Patch12: at-3.1.10-session.patch
Patch13: at-3.1.10-havepam.patch
# included in another pam patch
#Patch14: at-3.1.10-pam_keyring.patch
Patch15: at-3.1.10-PIE.patch
Patch16: at-3.1.10-pamfix.patch
Patch17: at-3.1.10-nonposix.patch
Patch18: at-3.1.10-selinux_mail.patch
Patch19: at-3.1.10-man_hyphen.patch
Patch20: at-3.1.10-different_shell.patch
Patch21: at-3.1.10-nowrap.patch
Patch22: at-3.1.10-parsetime.patch

BuildRequires: fileutils chkconfig /etc/init.d
BuildRequires: flex bison autoconf
BuildRequires: libselinux-devel >= 1.27.9

%if %{WITH_PAM}
BuildRequires: pam-devel
%endif
Conflicts: crontabs <= 1.5
# No, I'm not kidding
BuildRequires: smtpdaemon
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
At and batch read commands from standard input or from a specified
file. At allows you to specify that a command will be run at a
particular time. Batch will execute commands when the system load
levels drop to a particular level. Both commands use user's shell.

You should install the at package if you need a utility for
time-oriented job control. Note: If it is a recurring job that will
need to be repeated at the same time every day/week, etc. you should
use crontab instead.

%prep
%setup -q

cp %{SOURCE1} .
%patch0 -p1 -b .lockfile
%patch1 -p1 -b .make
%patch2 -p1 -b .paths
%patch3 -p1 -b .sigchld
%patch4 -p1 -b .typo
%patch5 -p1 -b .perr
%patch6 -p1 -b .shell
%patch7 -p1 -b .t_option
%patch8 -p1 -b .pam
%patch9 -p1 -b .dont_fork
%patch10 -p1 -b .perm
%patch11 -p1 -b .opt_V
%patch12 -p1 -b .session
%patch13 -p1 -b .havepam
%patch15 -p1 -b .PIE
%patch16 -p1 -b .pamfix
%patch17 -p1 -b .nonposix
%patch18 -p1 -b .mailselinux
%patch19 -p1 -b .hyphen
%patch20 -p1 -b .fixshell
%patch21 -p1 -b .nowrap
%patch22 -p1 -b .parsetime

%build
# patch10 touches configure.in
autoconf
# for patch11
rm -f lex.yy.* y.tab.*
%configure --with-atspool=%{_localstatedir}/spool/at/spool \
	--with-jobdir=%{_localstatedir}/spool/at \
	--with-daemon_username=root  \
	--with-daemon_groupname=root \
	--with-selinux \
%if %{WITH_PAM}
	--with-pam
%endif

make

%check
# don't run "make test" by default
%{?_without_check: %define _without_check 1}
%{!?_without_check: %define _without_check 1}

%if ! %{_without_check}
	LANG=C make test > /dev/null
%endif

%install
make install \
	DAEMON_USERNAME=`id -nu`\
	DAEMON_GROUPNAME=`id -ng` \
	DESTDIR=%{buildroot}\
	sbindir=%{buildroot}%{_prefix}/sbin\
	bindir=%{buildroot}%{_bindir}\
	prefix=%{buildroot}%{_prefix}\
	exec_prefix=%{buildroot}%{_prefix}\
	docdir=%{buildroot}/usr/doc\
	mandir=%{buildroot}%{_mandir}\
	etcdir=%{buildroot}%{_sysconfdir} \
	ATJOB_DIR=%{buildroot}%{_localstatedir}/spool/at \
	ATSPOOL_DIR=%{buildroot}%{_localstatedir}/spool/at/spool \
	INSTALL_ROOT_USER=`id -nu` \
	INSTALL_ROOT_GROUP=`id -nu`;

echo > %{buildroot}%{_sysconfdir}/at.deny
mkdir docs
cp  %{buildroot}/%{_prefix}/doc/at/* docs/

mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
install -m 755 %{SOURCE2} %{buildroot}%{_sysconfdir}/rc.d/init.d/atd

mv -f %{buildroot}/%{_mandir}/man5/at_allow.5 \
	%{buildroot}/%{_mandir}/man5/at.allow.5
rm -f %{buildroot}/%{_mandir}/man5/at_deny.5
#ln -s at.allow.5 %{buildroot}/%{_mandir}/man5/at.deny.5

mkdir -p %{buildroot}/etc/sysconfig
install -m 755 %{SOURCE3} %{buildroot}/etc/sysconfig/atd

mkdir -p %{buildroot}/%{_libdir}/pm-utils/sleep.d/
install -m 755 %{SOURCE4} %{buildroot}/%{_libdir}/pm-utils/sleep.d/56atd

# remove unpackaged files from the buildroot
rm -r  %{buildroot}%{_prefix}/doc

%clean
rm -rf %{buildroot}

%post
touch %{_localstatedir}/spool/at/.SEQ
chmod 600 %{_localstatedir}/spool/at/.SEQ
chown daemon:daemon %{_localstatedir}/spool/at/.SEQ
# must be in chkconfig on
/sbin/chkconfig --add atd

%preun
if [ "$1" = "0" ] ; then
	/sbin/service atd stop >/dev/null 2>&1 ||:
	/sbin/chkconfig --del atd
fi

%postun
if [ "$1" -ge "1" ]; then
	/sbin/service atd condrestart >/dev/null 2>&1 ||:
fi

%files
%defattr(-,root,root,-)
%doc docs/*
%attr(0644,root,root)       %config(noreplace) %{_sysconfdir}/at.deny
%attr(0644,root,root)       %config(noreplace) %{_sysconfdir}/sysconfig/atd
%attr(0755,root,root)		%{_sysconfdir}/rc.d/init.d/atd
%attr(0700,daemon,daemon)	%dir %{_localstatedir}/spool/at
%attr(0600,daemon,daemon)	%verify(not md5 size mtime) %ghost %{_localstatedir}/spool/at/.SEQ
%attr(0700,daemon,daemon)	%dir %{_localstatedir}/spool/at/spool
%attr(0644,root,root)		%config(noreplace) %{_sysconfdir}/pam.d/atd
%{_sbindir}/atrun
%attr(0755,root,root)		%{_sbindir}/atd
%{_mandir}/man*/*
%{_bindir}/batch
%{_bindir}/atrm
%{_bindir}/atq
%attr(4755,root,root)		%{_bindir}/at
%attr(0755,root,root)		%{_libdir}/pm-utils/sleep.d/56atd


%changelog

